//+------------------------------------------------------------------+
//|                                                 ZeroLag Tema.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 PaleVioletRed
#property indicator_color4 PaleVioletRed
#property indicator_color5 DeepSkyBlue
#property indicator_color6 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//

#define PRICE_HA 7
   extern int  iPerioda            = 144;
   extern int  iPricea             = PRICE_TYPICAL;
   extern int  iPeriodb            =  21;
   extern int  iPriceb             = PRICE_HA;
   extern bool ShowColorsOnCrosses = false;
   extern bool MultiColorMode      = true;

//
//
//
//
//

double buffer1[];
double buffer1Da[];
double buffer1Db[];
double buffer2[];
double buffer2Ua[];
double buffer2Ub[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    SetIndexBuffer(0,buffer1);
    SetIndexBuffer(1,buffer1Da);
    SetIndexBuffer(2,buffer1Db);
    SetIndexBuffer(3,buffer2);
    SetIndexBuffer(4,buffer2Ua);
    SetIndexBuffer(5,buffer2Ub);

   //
   //
   //
   //
   //
            
   IndicatorShortName("ZeroLag TEMA ("+iPerioda+","+iPeriodb+")");
      SetIndexLabel(0,"ZL TEMA "+iPerioda);
      SetIndexLabel(1,"ZL TEMA "+iPerioda);
      SetIndexLabel(2,"ZL TEMA "+iPerioda);
      SetIndexLabel(3,"ZL TEMA "+iPeriodb);
      SetIndexLabel(4,"ZL TEMA "+iPeriodb);
      SetIndexLabel(5,"ZL TEMA "+iPeriodb);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double   work[][9];
#define _trendSlope1 6
#define _trendSlope2 7
#define _trendCross  8

//
//
//
//
//

int start()
{
   double alphaa = 2.0 / (1.0 + iPerioda);
   double alphab = 2.0 / (1.0 + iPeriodb);
   int    counted_bars = IndicatorCounted();
   int    i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
   
   //
   //
   //
   //
   //

      if (MultiColorMode && !ShowColorsOnCrosses && work[Bars-limit-1][_trendSlope1]==-1) CleanPoint(limit,buffer1Da,buffer1Db);
      if (MultiColorMode && !ShowColorsOnCrosses && work[Bars-limit-1][_trendSlope2]== 1) CleanPoint(limit,buffer2Ua,buffer2Ub);
      if (MultiColorMode && ShowColorsOnCrosses  && work[Bars-limit-1][_trendCross] ==-1)
      { 
         CleanPoint(limit,buffer1Da,buffer1Db);
         CleanPoint(limit,buffer2Ua,buffer2Ub); 
      }
   
   //
   //
   //
   //
   //
   
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {  
      if (iPerioda > 1)
         {
            double tema1 = calculateTEMA(i,iPerioda,iPricea,0);
               work[r][0] = work[r-1][0]+alphaa*(tema1     -work[r-1][0]);
               work[r][1] = work[r-1][1]+alphaa*(work[r][0]-work[r-1][1]);
               work[r][2] = work[r-1][2]+alphaa*(work[r][1]-work[r-1][2]);
               buffer1[i] = tema1+(tema1-(3*work[r][0]-3*work[r][1]+work[r][2])); 
         }               
         
      //
      //
      //
      //
      //
               
      if (iPeriodb > 1)
         {
            double tema2 = calculateTEMA(i,iPeriodb,iPriceb,1);
               work[r][3] = work[r-1][3]+alphab*(tema2     -work[r-1][3]);
               work[r][4] = work[r-1][4]+alphab*(work[r][3]-work[r-1][4]);
               work[r][5] = work[r-1][5]+alphab*(work[r][4]-work[r-1][5]);
               buffer2[i] = tema2+(tema2-(3*work[r][3]-3*work[r][4]+work[r][5])); 
         }

      //
      //
      //
      //
      //
      
      work[r][_trendSlope1] = work[r-1][_trendSlope1];
         if (buffer1[i]>buffer1[i+1]) work[r][_trendSlope1] =  1;
         if (buffer1[i]<buffer1[i+1]) work[r][_trendSlope1] = -1;
      work[r][_trendSlope2] = work[r-1][_trendSlope2];
         if (buffer2[i]>buffer2[i+1]) work[r][_trendSlope2] =  1;
         if (buffer2[i]<buffer2[i+1]) work[r][_trendSlope2] = -1;
      work[r][_trendCross]  = work[r-1][_trendCross];
         if (buffer1[i]>buffer2[i]) work[r][_trendCross] =  1;
         if (buffer1[i]<buffer2[i]) work[r][_trendCross] = -1;
   
      //
      //
      //
      //
      //
      
      buffer1Da[i] = EMPTY_VALUE;
      buffer1Db[i] = EMPTY_VALUE;
      buffer2Ua[i] = EMPTY_VALUE;
      buffer2Ub[i] = EMPTY_VALUE;
      if (MultiColorMode && !ShowColorsOnCrosses && work[r][_trendSlope1]==-1) PlotPoint(i,buffer1Da,buffer1Db,buffer1);
      if (MultiColorMode && !ShowColorsOnCrosses && work[r][_trendSlope2]== 1) PlotPoint(i,buffer2Ua,buffer2Ub,buffer2);
      if (MultiColorMode &&  ShowColorsOnCrosses && work[r][_trendCross] ==-1)
      {
         PlotPoint(i,buffer2Ua,buffer2Ub,buffer2);
         PlotPoint(i,buffer1Da,buffer1Db,buffer1);
      }
   }         
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workTema[][16];

double calculateTEMA(int i, int period, int usePrice, int instance)
{
   double alpha = 2.0 / (1.0 + period);
   int    index = instance*8;
   int    r     = Bars-i-1;
         if (ArrayRange(workTema,0)!=Bars) ArrayResize(workTema,Bars);

   //
   //
   //
   //
   //
      
      if (usePrice==PRICE_HA)
      {   
         double haOpen  = (workTema[r-1][index+6] + workTema[r-1][index+7]) / 2;
         double haClose = (Open[i] + High[i] + Low[i] + Close[i]) / 4;
         double haHigh  = MathMax(High[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(Low[i] , MathMin(haOpen,haClose));
      
         if(haOpen<haClose) { workTema[r][index+4] = haLow;  workTema[r][index+5] = haHigh; } 
         else               { workTema[r][index+4] = haHigh; workTema[r][index+5] = haLow;  } 
                              workTema[r][index+6] = haOpen;
                              workTema[r][index+7] = haClose;
         double price = (workTema[r][index+4]+workTema[r][index+5]+workTema[r][index+6]+workTema[r][index+7])/4.0;
      }
      else price = iMA(NULL,0,period,0,MODE_EMA,usePrice,i);
      
      //
      //
      //
      //
      //
              
      workTema[r][index+3] = workTema[r-1][index+3]+alpha*(price               -workTema[r-1][index+3]);
      workTema[r][index+2] = workTema[r-1][index+2]+alpha*(workTema[r][index+3]-workTema[r-1][index+2]);
      workTema[r][index+1] = workTema[r-1][index+1]+alpha*(workTema[r][index+2]-workTema[r-1][index+1]);
      workTema[r][index+0] = 3*workTema[r][index+3]-3*workTema[r][index+2]+workTema[r][index+1];

   //
   //
   //
   //
   //
   
   return(workTema[r][index+0]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}